﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Chess
{
    public class Bishop : Piece
    {
        public override IEnumerable<BoardCoordinate> GetMovesFrom(BoardCoordinate startingLocation, int boardSize)
        {
            var allDistancesFromStart = Enumerable.Range(1, boardSize);
            var allPossibleBoardCoordinates = allDistancesFromStart.SelectMany(r => GetRadialDiagonalFrom(startingLocation, r));
            var legalBoardCoordinates = allPossibleBoardCoordinates.Where(c => c.IsValidCoordinateForBoardSize(boardSize));
            return legalBoardCoordinates;
        }
    }
}
