﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chess
{
    public abstract class Piece
    {
        public bool HasMoved { get; set; }

        public abstract IEnumerable<BoardCoordinate> GetMovesFrom(BoardCoordinate bc, int boardSize);

        protected IEnumerable<BoardCoordinate> GetRadialDiagonalFrom(BoardCoordinate startingLocation, int distance)
        {
            yield return new BoardCoordinate(startingLocation.X + distance, startingLocation.Y + distance);
            yield return new BoardCoordinate(startingLocation.X - distance, startingLocation.Y - distance);
            yield return new BoardCoordinate(startingLocation.X + distance, startingLocation.Y - distance);
            yield return new BoardCoordinate(startingLocation.X - distance, startingLocation.Y + distance);
        }

        protected IEnumerable<BoardCoordinate> GetAdjacentFrom(BoardCoordinate startingLocation, int distance)
        {
            yield return new BoardCoordinate(startingLocation.X + distance, startingLocation.Y);
            yield return new BoardCoordinate(startingLocation.X - distance, startingLocation.Y);
            yield return new BoardCoordinate(startingLocation.X, startingLocation.Y - distance);
            yield return new BoardCoordinate(startingLocation.X, startingLocation.Y + distance);
        }
    }
}
