﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Chess
{
    public class Rook : Piece
    {
        public override IEnumerable<BoardCoordinate> GetMovesFrom(BoardCoordinate bc, int boardSize)
        {
            var availableCoordinates = Enumerable.Range(1, boardSize);

            var verticalMoves = availableCoordinates.Where(y => y != bc.Y).Select(y => new BoardCoordinate(bc.X, y));
            var horizontalMoves = availableCoordinates.Where(x => x != bc.X).Select(x => new BoardCoordinate(x, bc.Y));

            return verticalMoves.Union(horizontalMoves);
        }
    }
}
